]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blame - make.sh
iptables: Fix build without kernel source
[people/pmueller/ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
06ac8243 20# Copyright (C) 2007-2019 IPFire Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
e8ee3199
AF
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
b450e7e3 27VERSION="2.23" # Version number
7af7ced6 28CORE="132" # Core Level (Filename)
c33a6e71 29PAKFIRE_CORE="131" # Core Level (PAKFIRE)
595e89a8 30GIT_BRANCH=`git rev-parse --abbrev-ref HEAD` # Git Branch
e8ee3199
AF
31SLOGAN="www.ipfire.org" # Software slogan
32CONFIG_ROOT=/var/ipfire # Configuration rootdir
33NICE=10 # Nice level
34MAX_RETRIES=1 # prefetch/check loop
305a7b38 35BUILD_IMAGES=1 # Flash and Xen Downloader
15679d9f 36KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
e8ee3199
AF
37GIT_TAG=$(git tag | tail -1) # Git Tag
38GIT_LASTCOMMIT=$(git log | head -n1 | cut -d" " -f2 |head -c8) # Last commit
628e8c3a 39
1b24eec5 40TOOLCHAINVER=20181030
03ad5f93 41
7c984de6
MT
42ENABLE_RAMDISK="on"
43
69a6ec55
MT
44###############################################################################
45#
46# Beautifying variables & presentation & input output interface
47#
48###############################################################################
49
f9783277
MT
50# Remember if the shell is interactive or not
51if [ -t 0 ] && [ -t 1 ]; then
52 INTERACTIVE=true
53else
54 INTERACTIVE=false
55fi
56
401a1edc
MT
57# Sets or adjusts pretty formatting variables
58resize_terminal() {
59 ## Screen Dimentions
60 # Find current screen size
61 COLUMNS=$(tput cols)
62
63 # When using remote connections, such as a serial port, stty size returns 0
64 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
65 COLUMNS=80
66 fi
69a6ec55 67
401a1edc
MT
68 # Measurements for positioning result messages
69 OPTIONS_WIDTH=20
70 TIME_WIDTH=12
71 STATUS_WIDTH=8
72 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
73 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
74
e9a57acd
MT
75 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
76 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
401a1edc 77}
69a6ec55 78
401a1edc
MT
79# Initially setup terminal
80resize_terminal
f9783277 81
401a1edc
MT
82# Call resize_terminal when terminal is being resized
83trap "resize_terminal" WINCH
69a6ec55
MT
84
85# Define color for messages
86BOLD="\\033[1;39m"
87DONE="\\033[1;32m"
88SKIP="\\033[1;34m"
89WARN="\\033[1;35m"
90FAIL="\\033[1;31m"
91NORMAL="\\033[0;39m"
92
bcb9dc13 93# New architecture variables
dc7d6b20 94HOST_ARCH="$(uname -m)"
94571564 95
69a6ec55
MT
96PWD=$(pwd)
97BASENAME=$(basename $0)
98
15679d9f
MT
99# Debian specific settings
100if [ ! -e /etc/debian_version ]; then
df5e82b3 101 FULLPATH=`which $0`
15679d9f 102else
df5e82b3
MT
103 if [ -x /usr/bin/realpath ]; then
104 FULLPATH=`/usr/bin/realpath $0`
105 else
106 echo "ERROR: Need to do apt-get install realpath"
107 exit 1
108 fi
15679d9f 109fi
df5e82b3 110
69a6ec55 111# This is the directory where make.sh is in
aecbe123 112export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
69a6ec55 113
ebaecf2c
AF
114LOGFILE=$BASEDIR/log/_build.preparation.log
115export LOGFILE
15679d9f 116DIR_CHK=$BASEDIR/cache/check
ebaecf2c 117mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 118
69a6ec55
MT
119system_processors() {
120 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
121}
122
123system_memory() {
124 local key val unit
125
126 while read -r key val unit; do
127 case "${key}" in
128 MemTotal:*)
129 # Convert to MB
130 echo "$(( ${val} / 1024 ))"
131 break
132 ;;
133 esac
134 done < /proc/meminfo
135}
136
137configure_build() {
138 local build_arch="${1}"
139
140 if [ "${build_arch}" = "default" ]; then
141 build_arch="$(configure_build_guess)"
142 fi
143
144 case "${build_arch}" in
145 x86_64)
146 BUILDTARGET="${build_arch}-unknown-linux-gnu"
147 CROSSTARGET="${build_arch}-cross-linux-gnu"
148 BUILD_PLATFORM="x86"
7520b95a 149 CFLAGS_ARCH="-m64 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic"
69a6ec55
MT
150 ;;
151
152 i586)
153 BUILDTARGET="${build_arch}-pc-linux-gnu"
154 CROSSTARGET="${build_arch}-cross-linux-gnu"
155 BUILD_PLATFORM="x86"
7520b95a 156 CFLAGS_ARCH="-march=i586 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic -fomit-frame-pointer"
69a6ec55
MT
157 ;;
158
159 aarch64)
160 BUILDTARGET="${build_arch}-unknown-linux-gnu"
161 CROSSTARGET="${build_arch}-cross-linux-gnu"
162 BUILD_PLATFORM="arm"
840f0b9f 163 CFLAGS_ARCH=""
69a6ec55
MT
164 ;;
165
166 armv7hl)
167 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
168 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
169 BUILD_PLATFORM="arm"
170 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
171 ;;
172
173 armv5tel)
174 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
175 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
176 BUILD_PLATFORM="arm"
177 CFLAGS_ARCH="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
178 ;;
179
180 *)
181 exiterror "Cannot build for architure ${build_arch}"
182 ;;
183 esac
184
185 # Check if the QEMU helper is available if needed.
186 if qemu_is_required "${build_arch}"; then
187 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
188
189 if [ -n "${qemu_build_helper}" ]; then
190 QEMU_TARGET_HELPER="${qemu_build_helper}"
191 else
192 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
193 fi
194 fi
195
196 BUILD_ARCH="${build_arch}"
197 TOOLS_DIR="/tools_${BUILD_ARCH}"
198
199 # Enables hardening
54114eb0 200 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
69a6ec55
MT
201
202 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
203 CXXFLAGS="${CFLAGS}"
204
205 # Determine parallelism
eeee108f 206 # We assume that each process consumes about
297473d5 207 # 128MB of memory. Therefore we find out how
eeee108f 208 # many processes fit into memory.
297473d5 209 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
eeee108f
MT
210 local cpu_max=$(( ${SYSTEM_PROCESSORS} + 1 ))
211
212 local parallelism
213 if [ ${mem_max} -lt ${cpu_max} ]; then
214 parallelism=${mem_max}
215 else
216 parallelism=${cpu_max}
69a6ec55 217 fi
212f17c1 218
eeee108f
MT
219 # Use this as default PARALLELISM
220 DEFAULT_PARALLELISM="${parallelism}"
221
212f17c1
MT
222 # Compression parameters
223 # We use mode 8 for reasonable memory usage when decompressing
224 # but with overall good compression
225 XZ_OPT="-8"
226
227 # We try to use as many cores as possible
228 XZ_OPT="${XZ_OPT} -T0"
229
230 # We need to limit memory because XZ uses too much when running
231 # in parallel and it isn't very smart in limiting itself.
232 # We allow XZ to use up to 70% of all system memory.
deffc275 233 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
212f17c1
MT
234
235 # XZ memory cannot be larger than 2GB on 32 bit systems
236 case "${build_arch}" in
237 i*86|armv*)
238 if [ ${xz_memory} -gt 2048 ]; then
239 xz_memory=2048
240 fi
241 ;;
242 esac
243
244 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
69a6ec55
MT
245}
246
247configure_build_guess() {
248 case "${HOST_ARCH}" in
87487585
MT
249 x86_64)
250 echo "x86_64"
251 ;;
252 i?86)
69a6ec55
MT
253 echo "i586"
254 ;;
255
256 aarch64)
257 echo "aarch64"
258 ;;
259
260 armv7*|armv6*|armv5*)
261 echo "armv5tel"
262 ;;
263
264 *)
265 exiterror "Cannot guess build architecture"
266 ;;
267 esac
268}
269
f9783277
MT
270stdumount() {
271 umount $BASEDIR/build/sys 2>/dev/null;
272 umount $BASEDIR/build/dev/shm 2>/dev/null;
273 umount $BASEDIR/build/dev/pts 2>/dev/null;
274 umount $BASEDIR/build/dev 2>/dev/null;
275 umount $BASEDIR/build/proc 2>/dev/null;
276 umount $BASEDIR/build/install/mnt 2>/dev/null;
277 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
278 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
279 umount $BASEDIR/build/usr/src/config 2>/dev/null;
280 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
281 umount $BASEDIR/build/usr/src/html 2>/dev/null;
282 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
283 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
ebaecf2c 284 umount $BASEDIR/build/usr/src/log 2>/dev/null;
f9783277 285 umount $BASEDIR/build/usr/src/src 2>/dev/null;
7c984de6 286 umount $BASEDIR/build/usr/src 2>/dev/null;
f9783277
MT
287}
288
289now() {
290 date -u "+%s"
69a6ec55
MT
291}
292
f9783277
MT
293format_runtime() {
294 local seconds=${1}
295
296 if [ ${seconds} -ge 3600 ]; then
297 printf "%d:%02d:%02d\n" \
298 "$(( seconds / 3600 ))" \
299 "$(( seconds % 3600 / 60 ))" \
300 "$(( seconds % 3600 % 60 ))"
301 elif [ ${seconds} -ge 60 ]; then
302 printf "%d:%02d\n" \
303 "$(( seconds / 60 ))" \
304 "$(( seconds % 60 ))"
69a6ec55 305 else
f9783277 306 printf "%d\n" "${seconds}"
69a6ec55 307 fi
f9783277 308}
69a6ec55 309
f9783277
MT
310print_line() {
311 local line="$@"
69a6ec55 312
f9783277 313 printf "%-${LINE_WIDTH}s" "${line}"
69a6ec55
MT
314}
315
f9783277
MT
316_print_line() {
317 local status="${1}"
318 shift
69a6ec55 319
f9783277
MT
320 if ${INTERACTIVE}; then
321 printf "${!status}"
322 fi
69a6ec55 323
f9783277
MT
324 print_line "$@"
325
326 if ${INTERACTIVE}; then
327 printf "${NORMAL}"
328 fi
329}
330
331print_headline() {
332 _print_line BOLD "$@"
69a6ec55
MT
333}
334
f9783277
MT
335print_error() {
336 _print_line FAIL "$@"
337}
338
339print_package() {
340 local name="${1}"
341 shift
69a6ec55 342
f9783277
MT
343 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
344 local options="$@"
345
346 local string="${name}"
347 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
348 string="${string} (${version})"
349 fi
350
351 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
fa8c758e 352 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
f9783277
MT
353}
354
355print_runtime() {
356 local runtime=$(format_runtime $@)
357
358 if ${INTERACTIVE}; then
359 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
360 else
361 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
69a6ec55 362 fi
f9783277
MT
363}
364
365print_status() {
366 local status="${1}"
367
368 local color="${!status}"
369
370 if ${INTERACTIVE}; then
371 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
372 else
373 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
69a6ec55 374 fi
f9783277 375}
69a6ec55 376
f9783277
MT
377print_build_stage() {
378 print_headline "$@"
379
380 # end line
381 printf "\n"
69a6ec55
MT
382}
383
f9783277
MT
384print_build_summary() {
385 local runtime=$(format_runtime $@)
386
387 print_line "*** Build finished in ${runtime}"
388 print_status DONE
69a6ec55
MT
389}
390
391exiterror() {
392 stdumount
393 for i in `seq 0 7`; do
394 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
395 losetup -d /dev/loop${i} 2>/dev/null
396 fi;
397 done
398
f9783277 399 # Dump logfile
66028310 400 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
69a6ec55
MT
401 echo # empty line
402
403 local line
404 while read -r line; do
405 echo " ${line}"
406 done <<< "$(tail -n30 ${LOGFILE})"
407 fi
408
f9783277
MT
409 echo # empty line
410
411 local line
412 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
413 print_error "${line}"
414 print_status FAIL
415 done
416
69a6ec55
MT
417 exit 1
418}
419
aecbe123
MT
420prepareenv() {
421 # Are we running the right shell?
54328605 422 if [ -z "${BASH}" ]; then
aecbe123
MT
423 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
424 fi
425
426 if [ -z "${BASH_VERSION}" ]; then
427 exiterror "Not running BASH shell."
428 fi
429
430 # Trap on emergency exit
431 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
432
433 # Resetting our nice level
658232a6 434 if ! renice ${NICE} $$ >/dev/null; then
658232a6 435 exiterror "Failed to set nice level to ${NICE}"
aecbe123
MT
436 fi
437
438 # Checking if running as root user
658232a6 439 if [ $(id -u) -ne 0 ]; then
df7f30a1 440 exiterror "root privileges required for building"
aecbe123
MT
441 fi
442
443 # Checking for necessary temporary space
f9783277 444 print_line "Checking for necessary space on disk $BASE_DEV"
aecbe123
MT
445 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
446 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
447 if (( 2048000 > $BASE_ASPACE )); then
448 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
449 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
f9783277 450 print_status FAIL
aecbe123
MT
451 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
452 fi
453 else
f9783277 454 print_status DONE
aecbe123
MT
455 fi
456
457 # Set umask
458 umask 022
459
460 # Set LFS Directory
461 LFS=$BASEDIR/build
462
aecbe123
MT
463 # Setup environment
464 set +h
465 LC_ALL=POSIX
eeee108f 466 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM
aecbe123
MT
467 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
468
469 # Make some extra directories
470 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
471 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
472 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
473 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
7c984de6
MT
474
475 if [ "${ENABLE_RAMDISK}" = "on" ]; then
476 mkdir -p $BASEDIR/build/usr/src
477 mount -t tmpfs tmpfs -o size=4G,mode=1777 $BASEDIR/build/usr/src
478 fi
479
ebaecf2c 480 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
aecbe123
MT
481
482 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
483 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
484
485 # Make all sources and proc available under lfs build
486 mount --bind /dev $BASEDIR/build/dev
487 mount --bind /dev/pts $BASEDIR/build/dev/pts
488 mount --bind /dev/shm $BASEDIR/build/dev/shm
489 mount --bind /proc $BASEDIR/build/proc
490 mount --bind /sys $BASEDIR/build/sys
491 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
492 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
493 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
494 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
495 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
496 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
497 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
ebaecf2c 498 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
aecbe123
MT
499 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
500
501 # Run LFS static binary creation scripts one by one
502 export CCACHE_DIR=$BASEDIR/ccache
503 export CCACHE_COMPRESS=1
504 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
505
506 # Remove pre-install list of installed files in case user erase some files before rebuild
507 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
508
509 # Prepare string for /etc/system-release.
510 SYSTEM_RELEASE="${NAME} ${VERSION} (${BUILD_ARCH})"
511 if [ "$(git status -s | wc -l)" == "0" ]; then
512 GIT_STATUS=""
513 else
514 GIT_STATUS="-dirty"
515 fi
516 case "$GIT_BRANCH" in
517 core*|beta?|rc?)
518 SYSTEM_RELEASE="${SYSTEM_RELEASE} - $GIT_BRANCH$GIT_STATUS"
519 ;;
520 *)
521 SYSTEM_RELEASE="${SYSTEM_RELEASE} - Development Build: $GIT_BRANCH/$GIT_LASTCOMMIT$GIT_STATUS"
522 ;;
523 esac
524}
525
69a6ec55
MT
526enterchroot() {
527 # Install QEMU helper, if needed
528 qemu_install_helper
529
530 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
531
532 PATH="${PATH}" chroot ${LFS} env -i \
533 HOME="/root" \
534 TERM="${TERM}" \
535 PS1="${PS1}" \
536 PATH="${PATH}" \
537 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
538 PAKFIRE_CORE="${PAKFIRE_CORE}" \
539 NAME="${NAME}" \
540 SNAME="${SNAME}" \
541 VERSION="${VERSION}" \
542 CORE="${CORE}" \
543 SLOGAN="${SLOGAN}" \
544 TOOLS_DIR="${TOOLS_DIR}" \
545 CONFIG_ROOT="${CONFIG_ROOT}" \
546 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
547 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
548 BUILDTARGET="${BUILDTARGET}" \
549 CROSSTARGET="${CROSSTARGET}" \
550 BUILD_ARCH="${BUILD_ARCH}" \
551 BUILD_PLATFORM="${BUILD_PLATFORM}" \
552 CCACHE_DIR=/usr/src/ccache \
553 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
554 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
555 KVER="${KVER}" \
0d7a6f03 556 XZ_OPT="${XZ_OPT}" \
77c863a2 557 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
558 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
559 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
560 $(fake_environ) \
561 $(qemu_environ) \
562 "$@"
563}
564
565entershell() {
566 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
567 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
568 fi
569
570 echo "Entering to a shell inside LFS chroot, go out with exit"
ab8464f4 571 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
69a6ec55
MT
572
573 if enterchroot bash -i; then
574 stdumount
575 else
f9783277 576 print_status FAIL
69a6ec55
MT
577 exiterror "chroot error"
578 fi
579}
580
581lfsmakecommoncheck() {
582 # Script present?
583 if [ ! -f $BASEDIR/lfs/$1 ]; then
584 exiterror "No such file or directory: $BASEDIR/$1"
585 fi
586
f9783277
MT
587 # Print package name and version
588 print_package $@
69a6ec55
MT
589
590 # Check if this package is supported by our architecture.
591 # If no SUP_ARCH is found, we assume the package can be built for all.
592 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
593 # Check if package supports ${BUILD_ARCH} or all architectures.
594 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
405ee2b4 595 print_runtime 0
f9783277 596 print_status SKIP
69a6ec55
MT
597 return 1
598 fi
599 fi
600
601 # Script slipped?
602 local i
603 for i in $SKIP_PACKAGE_LIST
604 do
605 if [ "$i" == "$1" ]; then
f9783277 606 print_status SKIP
69a6ec55
MT
607 return 1;
608 fi
609 done
610
611 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
612
613 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
614 MESSAGE="$1\t " download >> $LOGFILE 2>&1
615 if [ $? -ne 0 ]; then
616 exiterror "Download error in $1"
617 fi
618
619 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
620 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
621 if [ $? -ne 0 ]; then
622 exiterror "md5sum error in $1, check file in cache or signature"
623 fi
624
625 return 0 # pass all!
626}
627
628lfsmake1() {
629 lfsmakecommoncheck $*
630 [ $? == 1 ] && return 0
631
69a6ec55
MT
632 cd $BASEDIR/lfs && env -i \
633 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
634 CCACHE_DIR="${CCACHE_DIR}" \
635 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
636 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
637 CFLAGS="${CFLAGS}" \
638 CXXFLAGS="${CXXFLAGS}" \
77c863a2 639 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
640 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
641 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
642 make -f $* \
643 TOOLCHAIN=1 \
644 TOOLS_DIR="${TOOLS_DIR}" \
645 CROSSTARGET="${CROSSTARGET}" \
646 BUILDTARGET="${BUILDTARGET}" \
647 BUILD_ARCH="${BUILD_ARCH}" \
648 BUILD_PLATFORM="${BUILD_PLATFORM}" \
649 LFS_BASEDIR="${BASEDIR}" \
650 ROOT="${LFS}" \
651 KVER="${KVER}" \
f9783277 652 install >> $LOGFILE 2>&1 &
69a6ec55 653
f9783277
MT
654 if ! wait_until_finished $!; then
655 print_status FAIL
656 exiterror "Building $*"
69a6ec55
MT
657 fi
658
f9783277 659 print_status DONE
69a6ec55
MT
660}
661
662lfsmake2() {
663 lfsmakecommoncheck $*
664 [ $? == 1 ] && return 0
665
69a6ec55
MT
666 local PS1='\u:\w$ '
667
668 enterchroot \
ce9264a1 669 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
69a6ec55
MT
670 make -f $* \
671 LFS_BASEDIR=/usr/src install" \
f9783277 672 >> ${LOGFILE} 2>&1 &
69a6ec55 673
f9783277
MT
674 if ! wait_until_finished $!; then
675 print_status FAIL
676 exiterror "Building $*"
69a6ec55
MT
677 fi
678
f9783277 679 print_status DONE
69a6ec55
MT
680}
681
682ipfiredist() {
683 lfsmakecommoncheck $*
684 [ $? == 1 ] && return 0
685
69a6ec55
MT
686 local PS1='\u:\w$ '
687
688 enterchroot \
689 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
f9783277 690 >> ${LOGFILE} 2>&1 &
69a6ec55 691
f9783277
MT
692 if ! wait_until_finished $!; then
693 print_status FAIL
694 exiterror "Packaging $*"
695 fi
69a6ec55 696
f9783277
MT
697 print_status DONE
698}
699
700wait_until_finished() {
701 local pid=${1}
702
703 local start_time=$(now)
704
705 # Show progress
706 if ${INTERACTIVE}; then
707 # Wait a little just in case the process
708 # has finished very quickly.
709 sleep 0.1
710
711 local runtime
712 while kill -0 ${pid} 2>/dev/null; do
713 print_runtime $(( $(now) - ${start_time} ))
714
715 # Wait a little
716 sleep 1
717 done
69a6ec55 718 fi
f9783277
MT
719
720 # Returns the exit code of the child process
721 wait ${pid}
722 local ret=$?
723
724 if ! ${INTERACTIVE}; then
725 print_runtime $(( $(now) - ${start_time} ))
726 fi
727
728 return ${ret}
69a6ec55
MT
729}
730
731fake_environ() {
732 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
733
734 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
735
736 # Fake kernel version, because some of the packages do not compile
737 # with kernel 3.0 and later.
738 env="${env} UTS_RELEASE=${KVER}"
739
740 # Fake machine version.
741 env="${env} UTS_MACHINE=${BUILD_ARCH}"
742
743 echo "${env}"
744}
745
746qemu_environ() {
747 local env
748
749 # Don't add anything if qemu is not used.
750 if ! qemu_is_required; then
751 return
752 fi
753
754 # Set default qemu options
755 case "${BUILD_ARCH}" in
756 arm*)
757 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
758
759 env="${env} QEMU_CPU=${QEMU_CPU}"
760 ;;
761 esac
762
763 # Enable QEMU strace
764 #env="${env} QEMU_STRACE=1"
765
766 echo "${env}"
767}
768
769qemu_is_required() {
770 local build_arch="${1}"
771
772 if [ -z "${build_arch}" ]; then
773 build_arch="${BUILD_ARCH}"
774 fi
775
776 case "${HOST_ARCH},${build_arch}" in
777 x86_64,arm*|i?86,arm*|i?86,x86_64)
778 return 0
779 ;;
780 *)
781 return 1
782 ;;
783 esac
784}
785
786qemu_install_helper() {
787 # Do nothing, if qemu is not required
788 if ! qemu_is_required; then
789 return 0
790 fi
791
792 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
793 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
794 fi
795
796 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
797 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
798 fi
799
800
801 if [ -z "${QEMU_TARGET_HELPER}" ]; then
802 exiterror "QEMU_TARGET_HELPER not set"
803 fi
804
805 # Check if the helper is already installed.
806 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
807 return 0
808 fi
809
810 # Try to find a suitable binary that we can install
811 # to the build environment.
812 local file
813 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
814 # file must exist and be executable.
815 [ -x "${file}" ] || continue
816
817 # Must be static.
818 file_is_static "${file}" || continue
819
820 local dirname="${LFS}$(dirname "${file}")"
821 mkdir -p "${dirname}"
822
823 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
824 return 0
825 done
826
827 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
828}
829
830qemu_find_build_helper_name() {
831 local build_arch="${1}"
832
833 local magic
834 case "${build_arch}" in
835 arm*)
836 magic="7f454c4601010100000000000000000002002800"
837 ;;
838 x86_64)
839 magic="7f454c4602010100000000000000000002003e00"
840 ;;
841 esac
842
843 [ -z "${magic}" ] && return 1
844
845 local file
846 for file in /proc/sys/fs/binfmt_misc/*; do
847 # skip write only register entry
848 [ $(basename "${file}") = "register" ] && continue
849 # Search for the file with the correct magic value.
850 grep -qE "^magic ${magic}$" "${file}" || continue
851
852 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
853
854 [ -n "${interpreter}" ] || continue
855 [ "${interpreter:0:1}" = "/" ] || continue
856 [ -x "${interpreter}" ] || continue
857
858 echo "${interpreter}"
859 return 0
860 done
861
862 return 1
863}
864
865file_is_static() {
866 local file="${1}"
867
868 file ${file} 2>/dev/null | grep -q "statically linked"
869}
870
871update_language_list() {
872 local path="${1}"
873
874 local lang
875 for lang in ${path}/*.po; do
876 lang="$(basename "${lang}")"
877 echo "${lang%*.po}"
878 done | sort -u > "${path}/LINGUAS"
879}
880
1fb7f56e
MT
881contributors() {
882 local commits name
883
884 git shortlog --summary --numbered | while read -r commits name; do
885 echo "${name}"
886 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
887}
888
889update_contributors() {
890 echo -n "Updating list of contributors"
891
892 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
893
894 # Edit contributors into credits.cgi
895 awk -i inplace \
896 "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
897 "${BASEDIR}/html/cgi-bin/credits.cgi"
898
899 print_status DONE
900 return 0
901}
902
a98ab1d7
MT
903# Load configuration file
904if [ -f .config ]; then
905 . .config
906fi
907
813659f2
MT
908# TARGET_ARCH is BUILD_ARCH now
909if [ -n "${TARGET_ARCH}" ]; then
910 BUILD_ARCH="${TARGET_ARCH}"
911 unset TARGET_ARCH
912fi
913
85560933
MT
914# Get some information about the host system
915SYSTEM_PROCESSORS="$(system_processors)"
916SYSTEM_MEMORY="$(system_memory)"
917
dc7d6b20
MT
918if [ -n "${BUILD_ARCH}" ]; then
919 configure_build "${BUILD_ARCH}"
949544f5 920else
dc7d6b20 921 configure_build "default"
949544f5
MT
922fi
923
df5e82b3 924buildtoolchain() {
69a6ec55
MT
925 local error=false
926 case "${BUILD_ARCH}:${HOST_ARCH}" in
927 # x86_64
928 x86_64:x86_64)
929 # This is working.
930 ;;
931
932 # x86
933 i586:i586|i586:i686|i586:x86_64)
934 # These are working.
935 ;;
936 i586:*)
937 error=true
938 ;;
939
940 # ARM
941 arvm7hl:armv7hl|armv7hl:armv7l)
942 # These are working.
943 ;;
944
945 armv5tel:armv5tel|armv5tel:armv5tejl|armv5tel:armv6l|armv5tel:armv7l|armv5tel:aarch64)
946 # These are working.
947 ;;
948 armv5tel:*)
949 error=true
950 ;;
951 esac
952
953 ${error} && \
954 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
955
956 local gcc=$(type -p gcc)
957 if [ -z "${gcc}" ]; then
958 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
959 fi
960
6bd3a131
MT
961 # Check ${TOOLS_DIR} symlink
962 if [ -h "${TOOLS_DIR}" ]; then
963 rm -f "${TOOLS_DIR}"
964 fi
965
966 if [ ! -e "${TOOLS_DIR}" ]; then
967 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
968 fi
969
970 if [ ! -h "${TOOLS_DIR}" ]; then
971 exiterror "Could not create ${TOOLS_DIR} symbolic link"
972 fi
973
ebaecf2c 974 LOGFILE="$BASEDIR/log/_build.toolchain.log"
69a6ec55
MT
975 export LOGFILE
976
977 lfsmake1 stage1
978 lfsmake1 ccache PASS=1
979 lfsmake1 binutils PASS=1
980 lfsmake1 gcc PASS=1
981 lfsmake1 linux KCFG="-headers"
982 lfsmake1 glibc
983 lfsmake1 gcc PASS=L
984 lfsmake1 binutils PASS=2
985 lfsmake1 gcc PASS=2
54d54148 986 lfsmake1 zlib
69a6ec55
MT
987 lfsmake1 ccache PASS=2
988 lfsmake1 tcl
989 lfsmake1 expect
990 lfsmake1 dejagnu
991 lfsmake1 pkg-config
992 lfsmake1 ncurses
993 lfsmake1 bash
994 lfsmake1 bzip2
995 lfsmake1 automake
996 lfsmake1 coreutils
997 lfsmake1 diffutils
998 lfsmake1 findutils
999 lfsmake1 gawk
1000 lfsmake1 gettext
1001 lfsmake1 grep
1002 lfsmake1 gzip
1003 lfsmake1 m4
1004 lfsmake1 make
1005 lfsmake1 patch
1006 lfsmake1 perl
1007 lfsmake1 sed
1008 lfsmake1 tar
1009 lfsmake1 texinfo
1010 lfsmake1 xz
85439ac7 1011 lfsmake1 bison
11b5e5cb 1012 lfsmake1 flex
69a6ec55 1013 lfsmake1 fake-environ
7b93b62b 1014 lfsmake1 strip
69a6ec55 1015 lfsmake1 cleanup-toolchain
df5e82b3
MT
1016}
1017
1018buildbase() {
ebaecf2c 1019 LOGFILE="$BASEDIR/log/_build.base.log"
69a6ec55
MT
1020 export LOGFILE
1021 lfsmake2 stage2
1022 lfsmake2 linux KCFG="-headers"
1023 lfsmake2 man-pages
1024 lfsmake2 glibc
1025 lfsmake2 tzdata
1026 lfsmake2 cleanup-toolchain
1027 lfsmake2 zlib
1028 lfsmake2 binutils
1029 lfsmake2 gmp
1030 lfsmake2 gmp-compat
1031 lfsmake2 mpfr
1032 lfsmake2 libmpc
1033 lfsmake2 file
1034 lfsmake2 gcc
1035 lfsmake2 sed
1036 lfsmake2 autoconf
1037 lfsmake2 automake
1038 lfsmake2 berkeley
1039 lfsmake2 coreutils
1040 lfsmake2 iana-etc
1041 lfsmake2 m4
1042 lfsmake2 bison
69a6ec55
MT
1043 lfsmake2 ncurses
1044 lfsmake2 procps
1045 lfsmake2 libtool
1046 lfsmake2 perl
1047 lfsmake2 readline
1048 lfsmake2 readline-compat
1049 lfsmake2 bzip2
3ece7859 1050 lfsmake2 xz
69a6ec55
MT
1051 lfsmake2 pcre
1052 lfsmake2 pcre-compat
1053 lfsmake2 bash
1054 lfsmake2 diffutils
1055 lfsmake2 e2fsprogs
1056 lfsmake2 ed
1057 lfsmake2 findutils
1058 lfsmake2 flex
1059 lfsmake2 gawk
1060 lfsmake2 gettext
1061 lfsmake2 grep
1062 lfsmake2 groff
1063 lfsmake2 gperf
1064 lfsmake2 gzip
1065 lfsmake2 hostname
1066 lfsmake2 iproute2
1067 lfsmake2 jwhois
1068 lfsmake2 kbd
1069 lfsmake2 less
4720fa0d 1070 lfsmake2 pkg-config
69a6ec55
MT
1071 lfsmake2 make
1072 lfsmake2 man
1073 lfsmake2 kmod
1074 lfsmake2 net-tools
1075 lfsmake2 patch
1076 lfsmake2 psmisc
1077 lfsmake2 shadow
1078 lfsmake2 sysklogd
1079 lfsmake2 sysvinit
1080 lfsmake2 tar
1081 lfsmake2 texinfo
1082 lfsmake2 util-linux
1083 lfsmake2 udev
1084 lfsmake2 vim
df5e82b3
MT
1085}
1086
15679d9f 1087buildipfire() {
ebaecf2c 1088 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 1089 export LOGFILE
489145db
MT
1090 lfsmake2 configroot
1091 lfsmake2 initscripts
1092 lfsmake2 backup
c38f55fe
MT
1093 lfsmake2 openssl
1094 [ "${BUILD_ARCH}" = "i586" ] && lfsmake2 openssl KCFG='-sse2'
3755e358 1095 lfsmake2 popt
d4767896 1096 lfsmake2 libedit
489145db
MT
1097 lfsmake2 libusb
1098 lfsmake2 libusb-compat
1099 lfsmake2 libpcap
1100 lfsmake2 ppp
1101 lfsmake2 pptp
1102 lfsmake2 unzip
1103 lfsmake2 which
1104 lfsmake2 linux-firmware
489145db 1105 lfsmake2 dvb-firmwares
37b86fa9 1106 lfsmake2 xr819-firmware
489145db
MT
1107 lfsmake2 zd1211-firmware
1108 lfsmake2 rpi-firmware
26796f3a 1109 lfsmake2 intel-microcode
0e54ca26 1110 lfsmake2 pcengines-apu-firmware
489145db 1111 lfsmake2 bc
2a0947f2 1112 lfsmake2 u-boot MKIMAGE=1
489145db
MT
1113 lfsmake2 cpio
1114 lfsmake2 mdadm
1115 lfsmake2 dracut
de18b4de 1116 lfsmake2 libaio
489145db
MT
1117 lfsmake2 lvm2
1118 lfsmake2 multipath-tools
1119 lfsmake2 freetype
1120 lfsmake2 grub
fd80e500
MT
1121 lfsmake2 efivar
1122 lfsmake2 efibootmgr
489145db
MT
1123 lfsmake2 libmnl
1124 lfsmake2 libnfnetlink
1125 lfsmake2 libnetfilter_queue
1126 lfsmake2 libnetfilter_conntrack
1127 lfsmake2 libnetfilter_cthelper
1128 lfsmake2 libnetfilter_cttimeout
1129 lfsmake2 iptables
0245f3b6 1130 lfsmake2 screen
54ead8ef 1131 lfsmake2 elfutils
8e6fb99d 1132
dc7d6b20 1133 case "${BUILD_ARCH}" in
68a36e26 1134 x86_64|aarch64)
489145db 1135 lfsmake2 linux KCFG=""
b389d731
AF
1136# lfsmake2 backports KCFG=""
1137# lfsmake2 e1000e KCFG=""
1138# lfsmake2 igb KCFG=""
1139# lfsmake2 ixgbe KCFG=""
489145db
MT
1140 lfsmake2 xtables-addons KCFG=""
1141 lfsmake2 linux-initrd KCFG=""
fc155193 1142 ;;
3d02c091
MT
1143 i586)
1144 # x86-pae (Native and new XEN) kernel build
489145db 1145 lfsmake2 linux KCFG="-pae"
b389d731
AF
1146# lfsmake2 backports KCFG="-pae"
1147# lfsmake2 e1000e KCFG="-pae"
1148# lfsmake2 igb KCFG="-pae"
1149# lfsmake2 ixgbe KCFG="-pae"
489145db
MT
1150 lfsmake2 xtables-addons KCFG="-pae"
1151 lfsmake2 linux-initrd KCFG="-pae"
3d02c091
MT
1152
1153 # x86 kernel build
489145db 1154 lfsmake2 linux KCFG=""
b389d731
AF
1155# lfsmake2 backports KCFG=""
1156# lfsmake2 e1000e KCFG=""
1157# lfsmake2 igb KCFG=""
1158# lfsmake2 ixgbe KCFG=""
489145db
MT
1159 lfsmake2 xtables-addons KCFG=""
1160 lfsmake2 linux-initrd KCFG=""
3d02c091 1161 ;;
544f40d4 1162
3d02c091 1163 armv5tel)
3d02c091 1164 # arm-kirkwood (Dreamplug, ICY-Box ...) kernel build
489145db 1165 lfsmake2 linux KCFG="-kirkwood"
0a21d63f
AF
1166# lfsmake2 backports KCFG="-kirkwood"
1167# lfsmake2 e1000e KCFG="-kirkwood"
1168# lfsmake2 igb KCFG="-kirkwood"
1169# lfsmake2 ixgbe KCFG="-kirkwood"
489145db
MT
1170 lfsmake2 xtables-addons KCFG="-kirkwood"
1171 lfsmake2 linux-initrd KCFG="-kirkwood"
3d02c091
MT
1172
1173 # arm multi platform (Panda, Wandboard ...) kernel build
489145db 1174 lfsmake2 linux KCFG="-multi"
0a21d63f
AF
1175# lfsmake2 backports KCFG="-multi"
1176# lfsmake2 e1000e KCFG="-multi"
1177# lfsmake2 igb KCFG="-multi"
1178# lfsmake2 ixgbe KCFG="-multi"
489145db
MT
1179 lfsmake2 xtables-addons KCFG="-multi"
1180 lfsmake2 linux-initrd KCFG="-multi"
3d02c091
MT
1181 ;;
1182 esac
489145db 1183 lfsmake2 xtables-addons USPACE="1"
489145db
MT
1184 lfsmake2 libgpg-error
1185 lfsmake2 libgcrypt
1186 lfsmake2 libassuan
1187 lfsmake2 nettle
1a7db134 1188 lfsmake2 json-c
f3e62301 1189 lfsmake2 libconfig
489145db
MT
1190 lfsmake2 libevent
1191 lfsmake2 libevent2
1192 lfsmake2 expat
c8e9a7a8
WA
1193 lfsmake2 apr
1194 lfsmake2 aprutil
489145db
MT
1195 lfsmake2 unbound
1196 lfsmake2 gnutls
1197 lfsmake2 bind
1198 lfsmake2 dhcp
1199 lfsmake2 dhcpcd
1200 lfsmake2 boost
1201 lfsmake2 linux-atm
1202 lfsmake2 gdbm
1203 lfsmake2 pam
1204 lfsmake2 curl
1205 lfsmake2 tcl
1206 lfsmake2 sqlite
1207 lfsmake2 libffi
1208 lfsmake2 python
1209 lfsmake2 python3
1210 lfsmake2 ca-certificates
1211 lfsmake2 fireinfo
1212 lfsmake2 libnet
1213 lfsmake2 libnl
1214 lfsmake2 libnl-3
1215 lfsmake2 libidn
1216 lfsmake2 nasm
1217 lfsmake2 libjpeg
1218 lfsmake2 libjpeg-compat
1219 lfsmake2 libexif
1220 lfsmake2 libpng
1221 lfsmake2 libtiff
1222 lfsmake2 libart
1223 lfsmake2 gd
489145db
MT
1224 lfsmake2 slang
1225 lfsmake2 newt
1226 lfsmake2 libsmooth
1227 lfsmake2 attr
1228 lfsmake2 acl
1229 lfsmake2 libcap
b051eb68 1230 lfsmake2 libcap-ng
489145db
MT
1231 lfsmake2 pciutils
1232 lfsmake2 usbutils
1233 lfsmake2 libxml2
1234 lfsmake2 libxslt
1235 lfsmake2 BerkeleyDB
489145db
MT
1236 lfsmake2 cyrus-sasl
1237 lfsmake2 openldap
1238 lfsmake2 apache2
489145db
MT
1239 lfsmake2 web-user-interface
1240 lfsmake2 flag-icons
1241 lfsmake2 jquery
6033b271 1242 lfsmake2 bootstrap
489145db
MT
1243 lfsmake2 arping
1244 lfsmake2 beep
78dd680d
MT
1245 lfsmake2 libarchive
1246 lfsmake2 cmake
8a960584 1247 lfsmake2 cdrkit
489145db
MT
1248 lfsmake2 dosfstools
1249 lfsmake2 reiserfsprogs
1250 lfsmake2 xfsprogs
1251 lfsmake2 sysfsutils
1252 lfsmake2 fuse
1253 lfsmake2 ntfs-3g
1254 lfsmake2 ethtool
1255 lfsmake2 ez-ipupdate
1256 lfsmake2 fcron
1257 lfsmake2 perl-GD
1258 lfsmake2 GD-Graph
1259 lfsmake2 GD-TextUtil
1260 lfsmake2 perl-Device-SerialPort
1261 lfsmake2 perl-Device-Modem
1262 lfsmake2 perl-Apache-Htpasswd
1263 lfsmake2 gnupg
1264 lfsmake2 hdparm
1265 lfsmake2 sdparm
1266 lfsmake2 mtools
1267 lfsmake2 whatmask
1268 lfsmake2 conntrack-tools
1269 lfsmake2 libupnp
1270 lfsmake2 ipaddr
1271 lfsmake2 iputils
1272 lfsmake2 l7-protocols
489145db
MT
1273 lfsmake2 hwdata
1274 lfsmake2 logrotate
1275 lfsmake2 logwatch
1276 lfsmake2 misc-progs
1277 lfsmake2 nano
1278 lfsmake2 URI
1279 lfsmake2 HTML-Tagset
1280 lfsmake2 HTML-Parser
1281 lfsmake2 HTML-Template
1282 lfsmake2 Compress-Zlib
1283 lfsmake2 Digest
1284 lfsmake2 Digest-SHA1
1285 lfsmake2 Digest-HMAC
1286 lfsmake2 libwww-perl
1287 lfsmake2 Net-DNS
1288 lfsmake2 Net-IPv4Addr
1289 lfsmake2 Net_SSLeay
1290 lfsmake2 IO-Stringy
1291 lfsmake2 IO-Socket-SSL
1292 lfsmake2 Unix-Syslog
1293 lfsmake2 Mail-Tools
1294 lfsmake2 MIME-Tools
1295 lfsmake2 Net-Server
1296 lfsmake2 Convert-TNEF
1297 lfsmake2 Convert-UUlib
1298 lfsmake2 Archive-Tar
1299 lfsmake2 Archive-Zip
1300 lfsmake2 Text-Tabs+Wrap
1301 lfsmake2 Locale-Country
1302 lfsmake2 XML-Parser
1303 lfsmake2 Crypt-PasswdMD5
1304 lfsmake2 Net-Telnet
1305 lfsmake2 python-setuptools
1306 lfsmake2 python-clientform
1307 lfsmake2 python-mechanize
1308 lfsmake2 python-feedparser
1309 lfsmake2 python-rssdler
1310 lfsmake2 python-inotify
1311 lfsmake2 python-docutils
1312 lfsmake2 python-daemon
1313 lfsmake2 python-ipaddress
1314 lfsmake2 glib
f107bb39 1315 lfsmake2 GeoIP
489145db
MT
1316 lfsmake2 ntp
1317 lfsmake2 openssh
1318 lfsmake2 fontconfig
1319 lfsmake2 dejavu-fonts-ttf
70f6cba4 1320 lfsmake2 ubuntu-font-family
489145db
MT
1321 lfsmake2 freefont
1322 lfsmake2 pixman
1323 lfsmake2 cairo
1324 lfsmake2 pango
1325 lfsmake2 rrdtool
1326 lfsmake2 setserial
1327 lfsmake2 setup
1328 lfsmake2 libdnet
91cc908f 1329 lfsmake2 yaml
3498300d 1330 lfsmake2 libhtp
67752a95 1331 lfsmake2 suricata
489145db 1332 lfsmake2 oinkmaster
ef640882 1333 lfsmake2 ids-ruleset-sources
489145db
MT
1334 lfsmake2 squid
1335 lfsmake2 squidguard
1336 lfsmake2 calamaris
1337 lfsmake2 tcpdump
1338 lfsmake2 traceroute
1339 lfsmake2 vlan
1340 lfsmake2 wireless
1341 lfsmake2 pakfire
1342 lfsmake2 spandsp
adf3f4f4 1343 lfsmake2 lz4
489145db
MT
1344 lfsmake2 lzo
1345 lfsmake2 openvpn
489145db
MT
1346 lfsmake2 mpage
1347 lfsmake2 dbus
1348 lfsmake2 intltool
1349 lfsmake2 libdaemon
6064cd87 1350 lfsmake2 avahi
489145db 1351 lfsmake2 cups
489145db 1352 lfsmake2 lcms2
56170c2a 1353 lfsmake2 ghostscript
489145db
MT
1354 lfsmake2 qpdf
1355 lfsmake2 poppler
1356 lfsmake2 cups-filters
1357 lfsmake2 epson-inkjet-printer-escpr
1358 lfsmake2 foomatic
1359 lfsmake2 hplip
1360 lfsmake2 cifs-utils
1361 lfsmake2 krb5
1362 lfsmake2 samba
1363 lfsmake2 sudo
1364 lfsmake2 mc
1365 lfsmake2 wget
1366 lfsmake2 bridge-utils
489145db
MT
1367 lfsmake2 smartmontools
1368 lfsmake2 htop
1369 lfsmake2 chkconfig
1370 lfsmake2 postfix
1371 lfsmake2 fetchmail
1372 lfsmake2 cyrus-imapd
489145db
MT
1373 lfsmake2 clamav
1374 lfsmake2 spamassassin
1375 lfsmake2 amavisd
1376 lfsmake2 dma
1377 lfsmake2 alsa
1378 lfsmake2 mpfire
1379 lfsmake2 guardian
1380 lfsmake2 libid3tag
1381 lfsmake2 libmad
1382 lfsmake2 libogg
1383 lfsmake2 libvorbis
1384 lfsmake2 libdvbpsi
1385 lfsmake2 flac
1386 lfsmake2 lame
1387 lfsmake2 sox
41f8d642 1388 lfsmake2 soxr
489145db
MT
1389 lfsmake2 libshout
1390 lfsmake2 xvid
1391 lfsmake2 libmpeg2
489145db
MT
1392 lfsmake2 gnump3d
1393 lfsmake2 rsync
489145db
MT
1394 lfsmake2 libtirpc
1395 lfsmake2 rpcbind
14fb55a5 1396 lfsmake2 keyutils
489145db
MT
1397 lfsmake2 nfs
1398 lfsmake2 gnu-netcat
1399 lfsmake2 ncat
1400 lfsmake2 nmap
489145db
MT
1401 lfsmake2 etherwake
1402 lfsmake2 bwm-ng
1403 lfsmake2 sysstat
489145db
MT
1404 lfsmake2 strongswan
1405 lfsmake2 rng-tools
1406 lfsmake2 lsof
1407 lfsmake2 br2684ctl
1408 lfsmake2 pcmciautils
1409 lfsmake2 lm_sensors
1410 lfsmake2 liboping
1411 lfsmake2 collectd
1412 lfsmake2 elinks
1413 lfsmake2 igmpproxy
1414 lfsmake2 fbset
1415 lfsmake2 opus
1416 lfsmake2 python-six
1417 lfsmake2 python-pyparsing
1418 lfsmake2 spice-protocol
1419 lfsmake2 spice
1420 lfsmake2 sdl
1421 lfsmake2 libusbredir
43c3a386 1422 lfsmake2 libseccomp
489145db
MT
1423 lfsmake2 qemu
1424 lfsmake2 sane
1425 lfsmake2 netpbm
489145db 1426 lfsmake2 netsnmpd
489145db 1427 lfsmake2 nagios_nrpe
2af354c2 1428 lfsmake2 nagios-plugins
489145db 1429 lfsmake2 icinga
01c2ea6b 1430 lfsmake2 observium-agent
489145db
MT
1431 lfsmake2 ebtables
1432 lfsmake2 directfb
489145db 1433 lfsmake2 faad2
e91ceed6 1434 lfsmake2 alac
489145db
MT
1435 lfsmake2 ffmpeg
1436 lfsmake2 vdr
1437 lfsmake2 vdr_streamdev
489145db
MT
1438 lfsmake2 vdr_epgsearch
1439 lfsmake2 vdr_dvbapi
1440 lfsmake2 vdr_eepg
1441 lfsmake2 w_scan
1442 lfsmake2 icecast
1443 lfsmake2 icegenerator
1444 lfsmake2 mpd
1445 lfsmake2 libmpdclient
1446 lfsmake2 mpc
985741db 1447 lfsmake2 perl-Net-CIDR-Lite
489145db
MT
1448 lfsmake2 perl-Net-SMTP-SSL
1449 lfsmake2 perl-MIME-Base64
1450 lfsmake2 perl-Authen-SASL
1451 lfsmake2 perl-MIME-Lite
1452 lfsmake2 perl-Email-Date-Format
1453 lfsmake2 git
1454 lfsmake2 squidclamav
1455 lfsmake2 vnstat
1456 lfsmake2 iw
1457 lfsmake2 wpa_supplicant
1458 lfsmake2 hostapd
1459 lfsmake2 pycurl
1460 lfsmake2 urlgrabber
1461 lfsmake2 syslinux
1462 lfsmake2 tftpd
1463 lfsmake2 cpufrequtils
1464 lfsmake2 bluetooth
1465 lfsmake2 gutenprint
1466 lfsmake2 apcupsd
1467 lfsmake2 iperf
1468 lfsmake2 iperf3
1469 lfsmake2 7zip
1470 lfsmake2 lynis
1471 lfsmake2 streamripper
1472 lfsmake2 sshfs
1473 lfsmake2 taglib
489145db
MT
1474 lfsmake2 sslh
1475 lfsmake2 perl-gettext
1476 lfsmake2 perl-Sort-Naturally
1477 lfsmake2 vdradmin
1478 lfsmake2 miau
1479 lfsmake2 perl-DBI
489145db
MT
1480 lfsmake2 perl-DBD-SQLite
1481 lfsmake2 perl-File-ReadBackwards
489145db 1482 lfsmake2 openvmtools
489145db
MT
1483 lfsmake2 motion
1484 lfsmake2 joe
1485 lfsmake2 monit
1486 lfsmake2 nut
1487 lfsmake2 watchdog
1488 lfsmake2 libpri
1489 lfsmake2 libsrtp
b713ec03 1490 lfsmake2 jansson
489145db 1491 lfsmake2 asterisk
489145db
MT
1492 lfsmake2 usb_modeswitch
1493 lfsmake2 usb_modeswitch_data
1494 lfsmake2 zerofree
489145db
MT
1495 lfsmake2 minicom
1496 lfsmake2 ddrescue
489145db
MT
1497 lfsmake2 miniupnpd
1498 lfsmake2 client175
1499 lfsmake2 powertop
1500 lfsmake2 parted
1501 lfsmake2 swig
2a0947f2 1502 lfsmake2 u-boot
bf1e7598 1503 lfsmake2 u-boot-kirkwood
5c82a9f0 1504 lfsmake2 python-typing
489145db
MT
1505 lfsmake2 python-m2crypto
1506 lfsmake2 wireless-regdb
1507 lfsmake2 crda
1508 lfsmake2 libsolv
1509 lfsmake2 python-distutils-extra
1510 lfsmake2 python-lzma
1511 lfsmake2 python-progressbar
1512 lfsmake2 python-xattr
1513 lfsmake2 ddns
2d17377a 1514 lfsmake2 python3-setuptools
662b2a81 1515 lfsmake2 python3-setuptools-scm
9e25fe5c 1516 lfsmake2 python3-six
e0a05a80 1517 lfsmake2 python3-dateutil
d48ea6b5 1518 lfsmake2 python3-jmespath
a33ca4cc 1519 lfsmake2 python3-colorama
041d2116 1520 lfsmake2 python3-docutils
d2da17a1 1521 lfsmake2 python3-yaml
953f6f73 1522 lfsmake2 python3-s3transfer
d45d5247 1523 lfsmake2 python3-rsa
faa5472a 1524 lfsmake2 python3-pyasn1
4ab80c5d 1525 lfsmake2 python3-botocore
3be81987 1526 lfsmake2 python3-llfuse
def9f4a3 1527 lfsmake2 python3-msgpack
280ee7e7 1528 lfsmake2 aws-cli
489145db
MT
1529 lfsmake2 transmission
1530 lfsmake2 dpfhack
1531 lfsmake2 lcd4linux
1532 lfsmake2 mtr
489145db
MT
1533 lfsmake2 minidlna
1534 lfsmake2 acpid
1535 lfsmake2 fping
1536 lfsmake2 telnet
1537 lfsmake2 xinetd
1538 lfsmake2 gpgme
1539 lfsmake2 pygpgme
1540 lfsmake2 pakfire3
1541 lfsmake2 stress
1542 lfsmake2 libstatgrab
1543 lfsmake2 sarg
1544 lfsmake2 check_mk_agent
1545 lfsmake2 nginx
1546 lfsmake2 sendEmail
1547 lfsmake2 sysbench
1548 lfsmake2 strace
489145db
MT
1549 lfsmake2 ltrace
1550 lfsmake2 ipfire-netboot
1551 lfsmake2 lcdproc
1552 lfsmake2 bitstream
1553 lfsmake2 multicat
1554 lfsmake2 keepalived
1555 lfsmake2 ipvsadm
1556 lfsmake2 perl-Carp-Clan
1557 lfsmake2 perl-Date-Calc
1558 lfsmake2 perl-Date-Manip
1559 lfsmake2 perl-File-Tail
1560 lfsmake2 perl-TimeDate
1561 lfsmake2 swatch
1562 lfsmake2 tor
1563 lfsmake2 arm
1564 lfsmake2 wavemon
1565 lfsmake2 iptraf-ng
1566 lfsmake2 iotop
1567 lfsmake2 stunnel
489145db
MT
1568 lfsmake2 bacula
1569 lfsmake2 batctl
b62c826f
MT
1570 lfsmake2 perl-Font-TTF
1571 lfsmake2 perl-IO-String
489145db
MT
1572 lfsmake2 perl-PDF-API2
1573 lfsmake2 squid-accounting
1574 lfsmake2 pigz
1575 lfsmake2 tmux
1576 lfsmake2 perl-Text-CSV_XS
489145db
MT
1577 lfsmake2 haproxy
1578 lfsmake2 ipset
1579 lfsmake2 lua
1580 lfsmake2 dnsdist
1581 lfsmake2 bird
1a7db134 1582 lfsmake2 frr
489145db
MT
1583 lfsmake2 dmidecode
1584 lfsmake2 mcelog
1585 lfsmake2 rtpproxy
1586 lfsmake2 util-macros
1587 lfsmake2 libpciaccess
1588 lfsmake2 libyajl
1589 lfsmake2 libvirt
1590 lfsmake2 freeradius
1591 lfsmake2 perl-common-sense
1592 lfsmake2 perl-inotify2
1593 lfsmake2 perl-Net-IP
0d6cc79d 1594 lfsmake2 wio
773caa66 1595 lfsmake2 iftop
ddcd60f7 1596 lfsmake2 mdns-repeater
429af178 1597 lfsmake2 i2c-tools
4e9000b4 1598 lfsmake2 nss-myhostname
014b235a 1599 lfsmake2 dehydrated
c708fa15 1600 lfsmake2 shairport-sync
46114d79 1601 lfsmake2 borgbackup
2397e513 1602 lfsmake2 knot
e1982c69 1603 lfsmake2 spectre-meltdown-checker
06fc6170 1604 lfsmake2 zabbix_agentd
82d176d3 1605 lfsmake2 flashrom
2aca6aa0 1606 lfsmake2 firmware-update
d0817963 1607}
df5e82b3
MT
1608
1609buildinstaller() {
1610 # Run installer scripts one by one
ebaecf2c 1611 LOGFILE="$BASEDIR/log/_build.installer.log"
df5e82b3 1612 export LOGFILE
489145db
MT
1613 lfsmake2 memtest
1614 lfsmake2 installer
ce9264a1
AF
1615 # use toolchain bash for chroot to strip
1616 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
df5e82b3
MT
1617}
1618
1619buildpackages() {
ebaecf2c 1620 LOGFILE="$BASEDIR/log/_build.packages.log"
df5e82b3
MT
1621 export LOGFILE
1622 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 1623
df5e82b3
MT
1624
1625 # Generating list of packages used
dc4ae0b7 1626 print_line "Generating packages list from logs"
df5e82b3 1627 rm -f $BASEDIR/doc/packages-list
ebaecf2c
AF
1628 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1629 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 1630 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
1631 fi
1632 done
7471f6ab 1633 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 1634 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
1635 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1636 rm -f $BASEDIR/doc/packages-list
c9673262 1637 # packages-list.txt is ready to be displayed for wiki page
f9783277 1638 print_status DONE
4b06f504
MT
1639
1640 # Update changelog
e49f7f0d 1641 cd $BASEDIR
c43b07fd
AF
1642 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1643 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1644 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
df5e82b3 1645
9607771a 1646 # Create images for install
489145db 1647 lfsmake2 cdrom
bada0832 1648
4dc82852 1649 # Check if there is a loop device for building in virtual environments
841663e7
MT
1650 modprobe loop 2>/dev/null
1651 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
489145db 1652 lfsmake2 flash-images
4dc82852 1653 fi
c9673262 1654
6b417413 1655 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
c9673262 1656
0d909a4a 1657 ipfirepackages
e67a57fe 1658
489145db 1659 lfsmake2 xen-image
939c2a21 1660 mv $LFS/install/images/*.bz2 $BASEDIR >> $LOGFILE 2>&1
bada0832 1661
b307417f 1662 cd $BASEDIR
744a04ea
AF
1663
1664 # remove not useable iso on armv5tel (needed to build flash images)
dc7d6b20 1665 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
744a04ea 1666
92244a40 1667 for i in `ls *.bz2 *.img.xz *.iso`; do
b307417f
AF
1668 md5sum $i > $i.md5
1669 done
1670 cd $PWD
1671
e67a57fe
MT
1672 # Cleanup
1673 stdumount
1674 rm -rf $BASEDIR/build/tmp/*
1675
e67a57fe 1676 cd $PWD
e67a57fe
MT
1677}
1678
1679ipfirepackages() {
489145db 1680 lfsmake2 core-updates
5596077b
MT
1681
1682 local i
dc7d6b20 1683 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
5596077b 1684 i=$(basename ${i})
453b418b
MT
1685 if [ -e $BASEDIR/lfs/$i ]; then
1686 ipfiredist $i
1687 else
1688 echo -n $i
f9783277 1689 print_status SKIP
453b418b 1690 fi
fe7fe395 1691 done
78331e30 1692 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 1693 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 1694 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
1695}
1696
bcb9dc13
MT
1697while [ $# -gt 0 ]; do
1698 case "${1}" in
1699 --target=*)
c2e810de 1700 configure_build "${1#--target=}"
bcb9dc13
MT
1701 ;;
1702 -*)
1703 exiterror "Unknown configuration option: ${1}"
1704 ;;
1705 *)
1706 # Found a command, so exit options parsing.
1707 break
1708 ;;
1709 esac
1710 shift
1711done
1712
df5e82b3
MT
1713# See what we're supposed to do
1714case "$1" in
1715build)
f9783277
MT
1716 START_TIME=$(now)
1717
1718 # Clear screen
1719 ${INTERACTIVE} && clear
1720
f74072a2 1721 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
df5e82b3 1722 #only restore on a clean disk
6c4cc7ea 1723 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
df5e82b3 1724 if [ ! -n "$PACKAGE" ]; then
f9783277 1725 print_build_stage "Full toolchain compilation"
df5e82b3
MT
1726 prepareenv
1727 buildtoolchain
1728 else
f74072a2 1729 PACKAGENAME=${PACKAGE%.tar.xz}
f9783277 1730 print_build_stage "Packaged toolchain compilation"
df5e82b3 1731 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
f74072a2 1732 tar axf $PACKAGE
df5e82b3
MT
1733 prepareenv
1734 else
1735 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1736 fi
1737 fi
1738 else
df5e82b3
MT
1739 prepareenv
1740 fi
5cfe86e6 1741
f9783277 1742 print_build_stage "Building LFS"
df5e82b3 1743 buildbase
15679d9f 1744
f9783277 1745 print_build_stage "Building IPFire"
15679d9f 1746 buildipfire
5cfe86e6 1747
f9783277 1748 print_build_stage "Building installer"
df5e82b3 1749 buildinstaller
15679d9f 1750
f9783277 1751 print_build_stage "Building packages"
df5e82b3 1752 buildpackages
7a5ed24e 1753
f9783277 1754 print_build_stage "Checking Logfiles for new Files"
b307417f
AF
1755
1756 cd $BASEDIR
7a5ed24e 1757 tools/checknewlog.pl
e0c923f4 1758 tools/checkrootfiles
b307417f 1759 cd $PWD
a23731d1 1760
f9783277 1761 print_build_summary $(( $(now) - ${START_TIME} ))
df5e82b3
MT
1762 ;;
1763shell)
1764 # enter a shell inside LFS chroot
1765 # may be used to changed kernel settings
1766 prepareenv
1767 entershell
1768 ;;
df5e82b3 1769clean)
f9783277
MT
1770 print_line "Cleaning build directory..."
1771
df5e82b3
MT
1772 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1773 $LOSETUP -d $i 2>/dev/null
1774 done
1775 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1776 umount $i
1777 done
1778 stdumount
1779 for i in `seq 0 7`; do
69a6ec55 1780 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
df5e82b3
MT
1781 umount /dev/loop${i} 2>/dev/null;
1782 losetup -d /dev/loop${i} 2>/dev/null;
69a6ec55 1783 fi;
df5e82b3
MT
1784 done
1785 rm -rf $BASEDIR/build
1786 rm -rf $BASEDIR/cdrom
f9315063 1787 rm -rf $BASEDIR/packages
ebaecf2c 1788 rm -rf $BASEDIR/log
6c4cc7ea
MT
1789 if [ -h "${TOOLS_DIR}" ]; then
1790 rm -f "${TOOLS_DIR}"
df5e82b3 1791 fi
b307417f 1792 rm -f $BASEDIR/ipfire-*
f9783277 1793 print_status DONE
df5e82b3 1794 ;;
4e432799
MT
1795docker)
1796 # Build the docker image if it does not exist, yet
1797 if ! docker images -a | grep -q ^ipfire-builder; then
1798 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1799 print_status DONE
1800 else
1801 print_status FAIL
1802 exit 1
1803 fi
1804 fi
1805
1806 # Run the container and enter a shell
1807 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1808 ;;
c3db995c 1809downloadsrc)
df5e82b3
MT
1810 if [ ! -d $BASEDIR/cache ]; then
1811 mkdir $BASEDIR/cache
1812 fi
ebaecf2c 1813 mkdir -p $BASEDIR/log
857d9bf2 1814 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
1815 FINISHED=0
1816 cd $BASEDIR/lfs
1817 for c in `seq $MAX_RETRIES`; do
1818 if (( FINISHED==1 )); then
1819 break
1820 fi
1821 FINISHED=1
1822 cd $BASEDIR/lfs
1823 for i in *; do
1824 if [ -f "$i" -a "$i" != "Config" ]; then
846e756e
MT
1825 lfsmakecommoncheck ${i} || continue
1826
dc7d6b20 1827 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1828 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
df5e82b3 1829 if [ $? -ne 0 ]; then
f9783277 1830 print_status FAIL
df5e82b3
MT
1831 FINISHED=0
1832 else
1833 if [ $c -eq 1 ]; then
f9783277 1834 print_status DONE
df5e82b3
MT
1835 fi
1836 fi
1837 fi
1838 done
1839 done
e22c7973 1840 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
1841 ERROR=0
1842 for i in *; do
1843 if [ -f "$i" -a "$i" != "Config" ]; then
a4130265 1844 lfsmakecommoncheck ${i} > /dev/null || continue
dc7d6b20 1845 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1846 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
df5e82b3 1847 if [ $? -ne 0 ]; then
e22c7973 1848 echo -ne "MD5 difference in lfs/$i"
f9783277 1849 print_status FAIL
df5e82b3
MT
1850 ERROR=1
1851 fi
1852 fi
1853 done
1854 if [ $ERROR -eq 0 ]; then
e22c7973 1855 echo -ne "${BOLD}all files md5sum match${NORMAL}"
f9783277 1856 print_status DONE
e22c7973
MT
1857 else
1858 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
f9783277 1859 print_status FAIL
df5e82b3 1860 fi
e22c7973 1861 cd - >/dev/null 2>&1
df5e82b3 1862 ;;
df5e82b3 1863toolchain)
f9783277
MT
1864 # Clear screen
1865 ${INTERACTIVE} && clear
1866
df5e82b3 1867 prepareenv
f3b7cf47 1868 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
df5e82b3 1869 buildtoolchain
f74072a2 1870 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
11104bfe 1871 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
ebaecf2c 1872 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log | xz ${XZ_OPT} \
b46f951e 1873 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz
f74072a2 1874 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
dc7d6b20 1875 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
df5e82b3
MT
1876 stdumount
1877 ;;
1878gettoolchain)
df5e82b3 1879 # arbitrary name to be updated in case of new toolchain package upload
dc7d6b20 1880 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
f74072a2 1881 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.xz ]; then
5bd13f01 1882 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
11104bfe 1883 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
f74072a2 1884 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
712d859c 1885 cd $BASEDIR/cache/toolchains
f74072a2 1886 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.xz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c 1887 if [ $? -ne 0 ]; then
dc7d6b20 1888 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
40a4ea4c 1889 else
f74072a2 1890 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
712d859c
MT
1891 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1892 else
1893 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1894 fi
40a4ea4c 1895 fi
712d859c
MT
1896 else
1897 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
1898 fi
1899 ;;
15679d9f
MT
1900uploadsrc)
1901 PWD=`pwd`
661d9388
CS
1902 if [ -z $IPFIRE_USER ]; then
1903 echo -n "You have to setup IPFIRE_USER first. See .config for details."
f9783277 1904 print_status FAIL
661d9388
CS
1905 exit 1
1906 fi
ae23a606 1907
661d9388 1908 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
15e38431 1909 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
661d9388 1910
15e38431
MT
1911 for file in ${BASEDIR}/cache/*; do
1912 [ -d "${file}" ] && continue
1913 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
661d9388 1914 NEW_FILES="$NEW_FILES $file"
0eab8e84 1915 done
661d9388
CS
1916 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
1917 cd $BASEDIR
15679d9f
MT
1918 cd $PWD
1919 exit 0
0eab8e84 1920 ;;
bf7c473f 1921lang)
69a6ec55
MT
1922 echo -ne "Checking the translations for missing or obsolete strings..."
1923 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1924 $BASEDIR/tools/sort_strings.pl en
1925 $BASEDIR/tools/sort_strings.pl de
1926 $BASEDIR/tools/sort_strings.pl fr
1927 $BASEDIR/tools/sort_strings.pl es
1928 $BASEDIR/tools/sort_strings.pl pl
1929 $BASEDIR/tools/sort_strings.pl ru
1930 $BASEDIR/tools/sort_strings.pl nl
1931 $BASEDIR/tools/sort_strings.pl tr
1932 $BASEDIR/tools/sort_strings.pl it
1933 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1934 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1935 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1936 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
1937 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.pl
1938 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1939 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1940 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1941 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1942 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
f9783277 1943 print_status DONE
69a6ec55
MT
1944
1945 echo -ne "Updating language lists..."
1946 update_language_list ${BASEDIR}/src/installer/po
1947 update_language_list ${BASEDIR}/src/setup/po
f9783277 1948 print_status DONE
bf7c473f 1949 ;;
1fb7f56e
MT
1950update-contributors)
1951 update_contributors
1952 ;;
6b8cff41 1953*)
1fb7f56e 1954 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors}"
6b8cff41
MT
1955 cat doc/make.sh-usage
1956 ;;
3ea75603 1957esac